unit Usemain;
{
Purpose : This unit is responsible for the user interface. It invokes the
          other modules of this project
Author  : Chris R  August 1996
Modified:
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, FileCtrl, StdCtrls,usemodul;

{}
type
  TfrmMain = class(TForm)
    Label1: TLabel;
    txtProject: TEdit;
    Label2: TLabel;
    txtSearch: TEdit;
    btnExecute: TButton;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    FilterComboBox1: TFilterComboBox;
    lbxModules: TListBox;
    lblProgress: TLabel;
    lbxWhereUsed: TListBox;
    Label3: TLabel;
    Label4: TLabel;
    btnsave: TButton;
    Label5: TLabel;
    Label6: TLabel;
    dlgSave: TSaveDialog;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure FilterComboBox1Change(Sender: TObject);
    procedure btnExecuteClick(Sender: TObject);
    procedure lbxModulesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AllowExecute(Sender: TObject);
    procedure btnsaveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ModuleList :TModuleList;
  end;

var
  frmMain: TfrmMain;

implementation
{$R *.DFM}

{}
procedure TfrmMain.AllowExecute(Sender: TObject);
begin
  btnExecute.enabled := (txtProject.text>'')
end;

{}
procedure TfrmMain.btnExecuteClick(Sender: TObject);
var
   i :integer;
begin
   with moduleList do
   begin
      FillFromScreen(txtProject.text,txtSearch.text);
      LbxModules.clear;
      PopulateList(lblProgress);
      for i := 1 to count-1 do
        with items[i] do
          if State <> msLibrary then
            lbxModules.items.add(FullPathName);
      btnSave.enabled := (count>1);
   end;
end;

{}
procedure TfrmMain.btnsaveClick(Sender: TObject);
begin
  if dlgsave.execute then
    ModuleList.SavetoDisk(dlgSave.filename);
end;

{}
procedure TfrmMain.DriveComboBox1Change(Sender: TObject);
begin
  DirectoryListBox1.drive := DriveComboBox1.drive;
end;

{}
procedure TfrmMain.DirectoryListBox1Change(Sender: TObject);
begin
   FileListBox1.directory := DirectoryListBox1.directory;
end;

{}
procedure TfrmMain.FileListBox1Click(Sender: TObject);
begin
   txtProject.text := FileListBox1.FileName;
end;


{}
procedure TfrmMain.FilterComboBox1Change(Sender: TObject);
begin
  FileListBox1.Mask := FilterComboBox1.Filter;
end;

{}
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  ModuleList := TModuleList.create;
end;

{}
procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  ModuleList.free;
end;

{}
procedure TfrmMain.lbxModulesClick(Sender: TObject);
begin
   if lbxModules.itemindex>=0 then
     ModuleList.GetWhereUsed(lbxModules.items[lbxModules.itemindex],lbxWhereUsed.items);
end;

end.
